#ifndef _COM_SUN_STAR_TASK_CLASSIFIEDINTERACTIONREQUEST_HPP_
#define _COM_SUN_STAR_TASK_CLASSIFIEDINTERACTIONREQUEST_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_TASK_CLASSIFIEDINTERACTIONREQUEST_HDL_
#include "com/sun/star/task/ClassifiedInteractionRequest.hdl"
#endif

#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include "com/sun/star/uno/Exception.hpp"
#endif
#ifndef _COM_SUN_STAR_TASK_INTERACTIONCLASSIFICATION_HPP_
#include "com/sun/star/task/InteractionClassification.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef INCLUDED_CPPU_UNOTYPE_HXX
#include "cppu/unotype.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif

namespace com { namespace sun { namespace star { namespace task {

inline ClassifiedInteractionRequest::ClassifiedInteractionRequest() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , Classification(::com::sun::star::task::InteractionClassification_ERROR)
{ }

inline ClassifiedInteractionRequest::ClassifiedInteractionRequest(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::com::sun::star::task::InteractionClassification& Classification_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , Classification(Classification_)
{ }

ClassifiedInteractionRequest::ClassifiedInteractionRequest(ClassifiedInteractionRequest const & the_other): ::com::sun::star::uno::Exception(the_other), Classification(the_other.Classification) {}

ClassifiedInteractionRequest::~ClassifiedInteractionRequest() {}

ClassifiedInteractionRequest & ClassifiedInteractionRequest::operator =(ClassifiedInteractionRequest const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    Classification = the_other.Classification;
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace task {

inline ::com::sun::star::uno::Type const & cppu_getUnoType(::com::sun::star::task::ClassifiedInteractionRequest const *) {
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.task.ClassifiedInteractionRequest" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
};

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::task::ClassifiedInteractionRequest const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::task::ClassifiedInteractionRequest >::get();
}

#endif // _COM_SUN_STAR_TASK_CLASSIFIEDINTERACTIONREQUEST_HPP_
